<id>
Last Online in Memberlist for YaBB 2.4
</id>

<author>
Thomas Mueller (ThM)
</author>

<homepage>
http://www.yabbforum.com
</homepage>

<version>
0.2
</version>

<mod info>
This small mod adds an additional column in your member list, which displays the date/time the member was last online. Special thanks to Deti. He helped with the sorting function.

- First relaese on February 04th, 2010
- Version 0.2 on February 05th, 2010 (Changing the default Sortorder)

Installation:

Use BoardMod or manually edit files.
Instructions:

Upload:

- Sources/Memberlist.pl (ASCII)
- Languages/English/Memberlist.lng (ASCII)
- Languages/English/Admin.lng (ASCII)
- Admin/ModList.pl (ASCII)
- Admin/ViewMembers.pl (ASCII)
- Admin/Settings_Main.pl (ASCII)
</mod info>


<edit file>
Sources/Memberlist.pl
</edit file>

<search for>
	if ($FORM{'sortform'} eq "regdate" || $INFO{'sort'} eq "regdate") { $selcReg .= qq( selected="selected"); $selReg .= qq(class="windowbg"); }
	else { $selReg .= qq(class="windowbg2"); }
</search for>

<add after>
	if ($FORM{'sortform'} eq "userlastlogin" || $INFO{'sort'} eq "userlastlogin") { $selcLastlogin .= qq( selected="selected"); $selLastlogin .= qq(class="windowbg"); }
	else { $selLastlogin .= qq(class="windowbg2"); }
</add after>

<search for>
	if ($FORM{'sortform'} eq "regdate"  || $INFO{'sort'} eq "regdate")  { &MLDate; }
</search for>

<add after>
	if ($FORM{'sortform'} eq "userlastlogin"  || $INFO{'sort'} eq "userlastlogin")  { &MLLastlogin; }
</add after>

<search for>
sub MLDate {
	($memcount, undef) = &MembershipGet;
	&buildIndex;
	&buildPages(1);
	fopen(MEMBERLISTREAD, "$memberdir/memberlist.txt");
	$counter = 0;
	while ($counter < $start && ($buffer = <MEMBERLISTREAD>)) { $counter++; }
	for ($counter = 0; $counter < $MembersPerPage && ($buffer = <MEMBERLISTREAD>); $counter++) {
		chomp $buffer;
		if ($buffer) {
			($membername, undef) = split(/\t/, $buffer, 2);
			&showRows($membername);
		}
	}
	fclose(MEMBERLISTREAD);
	&buildPages(0);
	$yytitle = "$ml_txt{'313'} $ml_txt{'4'} $ml_txt{'233'} $numshow";
	&template;
}
</search for>

<add after>
sub MLLastlogin {
     ( $memcount, undef ) = &MembershipGet;
     &buildIndex;
     &buildPages( 1 );

     my ( @memberlist, @x );
     ManageMemberlist( "load" );
     foreach ( keys %memberlist ) { push( @memberlist, $_ ) if &LoadUser( $_ ) }
     undef %memberlist;

     # sort numerically descending
     if ( $INFO{'sortdesc'} ) {
 	    @x = sort { ${$uid.$a}{'lastonline'} <=> ${$uid.$b}{'lastonline'} } @memberlist;
     }
     # sort numerically ascending
     else {
 	    @x = sort { ${$uid.$b}{'lastonline'} <=> ${$uid.$a}{'lastonline'} } @memberlist;
     }

     foreach ( splice( @x, $start, $MembersPerPage ) ) { &showRows( $_ ) }

     &buildPages( 0 );

     $yytitle = "$ml_txt{'313'} $ml_txt{'4'} $ml_txt{'233'} $numshow";
     &template;
}
</add after>

<search for>
		$dr_regdate =~ s~(.*)(, 1?[0-9]):[0-9][0-9].*~$1~;
</search for>

<add after>

		$userlastlogin = &timeformat(${$uid.$user}{'lastonline'});
		if ($userlastlogin eq "") { $userlastlogin = "$ml_txt{'235a'}"; }
</add after>

<search for>
		<td class="windowbg">$dr_regdate &nbsp;</td>
</search for>

<add after>
		<td class="windowbg">$userlastlogin &nbsp;</td>
</add after>

<search for>
		    <option value="regdate"$selcReg>$ml_txt{'233'}</option>
</search for>

<add after>
		    <option value="userlastlogin"$selcLastlogin>$ml_txt{'235'}</option>
</add after>

<search for>
		my $additional_headers;
		$headercount = 7;
</search for>

<replace>
		my $additional_headers;
		$headercount = 8;
</replace>

<search for>
		$TableHeader .= qq(
			<tr>
				<td $selUser onclick="location.href='$scripturl?action=ml;sort=username';" width="23%" align="center" style="border: 1px; border-style: outset; cursor: pointer;"><a href="$scripturl?action=ml;sort=username"><b>$ml_txt{'35'}</b></a></td>
				<td class="catbg" width="4%" align="center"><img src="$imagesdir/email.gif" border="0" alt="$ml_txt{'307'}" title="$ml_txt{'307'}" /></td>
				<td class="catbg" width="4%" align="center"><img src="$imagesdir/www.gif" border="0" alt="$ml_txt{'96'}" title="$ml_txt{'96'}" /></td>
				<td $selPos onclick="location.href='$scripturl?action=ml;sort=position';" width="23%" align="center" style="border: 1px; border-style: outset; cursor: pointer;"><a href="$scripturl?action=ml;sort=position"><b>$ml_txt{'87'}</b></a></td>
				<td $selPost onclick="location.href='$scripturl?action=ml;sort=posts';" width="23%" colspan="2" align="center" style="border: 1px; border-style: outset; cursor: pointer;"><a href="$scripturl?action=ml;sort=posts"><b>$ml_txt{'21'}</b></a></td>
				<td $selReg onclick="location.href='$scripturl?action=ml;sort=regdate';" width="23%" align="center" style="border: 1px; border-style: outset; cursor: pointer;"><a href="$scripturl?action=ml;sort=regdate"><b>$ml_txt{'234'}</b></a></td>
				$additional_headers
			</tr>
		);
</search for>

<replace>
		$TableHeader .= qq(
			<tr>
				<td $selUser onclick="location.href='$scripturl?action=ml;sort=username';" width="18%" align="center" style="border: 1px; border-style: outset; cursor: pointer;"><a href="$scripturl?action=ml;sort=username"><b>$ml_txt{'35'}</b></a></td>
				<td class="catbg" width="3%" align="center"><img src="$imagesdir/email.gif" border="0" alt="$ml_txt{'307'}" title="$ml_txt{'307'}" /></td>
				<td class="catbg" width="3%" align="center"><img src="$imagesdir/www.gif" border="0" alt="$ml_txt{'96'}" title="$ml_txt{'96'}" /></td>
				<td $selPos onclick="location.href='$scripturl?action=ml;sort=position';" width="18%" align="center" style="border: 1px; border-style: outset; cursor: pointer;"><a href="$scripturl?action=ml;sort=position"><b>$ml_txt{'87'}</b></a></td>
				<td $selPost onclick="location.href='$scripturl?action=ml;sort=posts';" width="18%" colspan="2" align="center" style="border: 1px; border-style: outset; cursor: pointer;"><a href="$scripturl?action=ml;sort=posts"><b>$ml_txt{'21'}</b></a></td>
				<td $selReg onclick="location.href='$scripturl?action=ml;sort=regdate';" width="18%" align="center" style="border: 1px; border-style: outset; cursor: pointer;"><a href="$scripturl?action=ml;sort=regdate"><b>$ml_txt{'234'}</b></a></td>
				<td $selLastlogin onclick="location.href='$scripturl?action=ml;sort=userlastlogin';" width="22%" align="center" style="border: 1px; border-style: outset; cursor: pointer;"><a href="$scripturl?action=ml;sort=userlastlogin"><b>$ml_txt{'235'}</b></a><br /><a href="$scripturl?action=ml;sort=userlastlogin;sortdesc=1"><b>$ml_txt{'235b'}</b></a></td>
				$additional_headers
			</tr>
		);
</replace>

<edit file>
Languages/English/Memberlist.lng
</edit file>

<search for>
'234' => 'Reg. Date',
</search for>

<add after>
'235' => 'Last Online',
'235a' => '<b><font color="red">No Login</font></b>',
'235b' => 'Reverse Result',
</add after>

<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
'905' => 'or',
</search for>

<add after>
'908' => 'Last Online',
</add after>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$lastlog = "Last Online in Memberlist|Thomas Mueller for YaBB 2.4 (<a href=\"http://www.yabbwelt.de\" target=\"_blank\">ThM</a>)|This small mod adds an additional column in your member list, which displays the date/time the member was last online.|0.1|February 04th, 2010";
	push (@installed_mods, "$lastlog");
</add before>

<edit file>
Admin/ViewMembers.pl
</edit file>

<search for>
	if ($FORM{'sortform'} eq 'lastonline' || $INFO{'sort'} eq 'lastonline') { $selLastOn .= qq~ selected="selected"~; &MLLastOnline; }
</search for>

<add after>
	if ($FORM{'sortform'} eq 'userlastlogin' || $INFO{'sort'} eq 'userlastlogin') { $selcLastlogin .= qq~ selected="selected"~; &MLLastOnline;}
</add after>

<edit file>
Admin/Settings_Main.pl
</edit file>

<search for>
  <option value="regdate"  ${isselected($defaultml eq 'regdate') }>$admin_txt{'909'}</option>
</search for>

<add after>
  <option value="userlastlogin"  ${isselected($defaultml eq 'userlastlogin') }>$admin_txt{'908'}</option>
</add after>